

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.data.offer_manager &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.data.offer_manager</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.data.offer_manager</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.models</span> <span class="k">import</span> <span class="n">Offer</span><span class="p">,</span> <span class="n">Prediction</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.database</span> <span class="k">import</span> <span class="n">dbSession</span> <span class="k">as</span> <span class="n">dB</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.prediction_manager</span> <span class="k">import</span> <span class="n">PredictionManager</span>


<div class="viewcode-block" id="OfferManager"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager">[docs]</a><span class="k">class</span> <span class="nc">OfferManager</span><span class="p">:</span>

<div class="viewcode-block" id="OfferManager.get_all_offers"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.get_all_offers">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_all_offers</span><span class="p">():</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        :return: All offer in the database</span>
<span class="sd">        :rtype: list</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offers</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">all</span><span class="p">()</span>
        <span class="k">return</span> <span class="p">[</span><span class="n">o</span><span class="o">.</span><span class="n">serialize</span><span class="p">()</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">offers</span><span class="p">]</span></div>

<div class="viewcode-block" id="OfferManager.get_offer_by_id"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.get_offer_by_id">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_offer_by_id</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :return: Offer with id_offer</span>
<span class="sd">        :rtype: Offer serialize</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">offer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">offer</span><span class="o">.</span><span class="n">serialize</span><span class="p">()</span></div>

<div class="viewcode-block" id="OfferManager.add_offer"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.add_offer">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">add_offer</span><span class="p">(</span><span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Add offer in database</span>

<span class="sd">        :param title: title of an offer</span>
<span class="sd">        :type title: str</span>

<span class="sd">        :param content: content of an offer</span>
<span class="sd">        :type content: str</span>

<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: Boolean if the offer was added in database</span>
<span class="sd">        :rtype: Boolean</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="p">(</span><span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">)</span>
        <span class="n">dB</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">offer</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="OfferManager.add_offer_v2"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.add_offer_v2">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">add_offer_v2</span><span class="p">(</span><span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Add offer in database</span>

<span class="sd">        :param title: title of an offer</span>
<span class="sd">        :type title: str</span>

<span class="sd">        :param content: content of an offer</span>
<span class="sd">        :type content: str</span>

<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: id of the offer added in database</span>
<span class="sd">        :rtype: int</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="p">(</span><span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">)</span>
        <span class="n">dB</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">offer</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="n">offer</span><span class="o">.</span><span class="n">id</span>
        <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="k">return</span> <span class="o">-</span><span class="mi">1</span></div>

<div class="viewcode-block" id="OfferManager.update_offer"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.update_offer">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">update_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">,</span> <span class="n">title</span><span class="p">,</span> <span class="n">content</span><span class="p">,</span> <span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Update an offer in database</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :param title: title of an offer</span>
<span class="sd">        :type title: str</span>

<span class="sd">        :param content: content of an offer</span>
<span class="sd">        :type content: str</span>

<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: Boolean if the offer was updated in database</span>
<span class="sd">        :rtype: Boolean</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">offer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">title</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">offer</span><span class="o">.</span><span class="n">title</span> <span class="o">=</span> <span class="n">title</span>
                <span class="k">if</span> <span class="n">content</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">offer</span><span class="o">.</span><span class="n">content</span> <span class="o">=</span> <span class="n">content</span>
                <span class="k">if</span> <span class="n">id_user</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">offer</span><span class="o">.</span><span class="n">id_user</span> <span class="o">=</span> <span class="n">id_user</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">True</span>
            <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="OfferManager.delete_offer"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.delete_offer">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">delete_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Delete an offer in database</span>

<span class="sd">        :param id_offer: id of an offer</span>
<span class="sd">        :type id_offer: int</span>

<span class="sd">        :return: Boolean if the offer was deleted in database</span>
<span class="sd">        :rtype: Boolean</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offer</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">offer</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">PredictionManager</span><span class="o">.</span><span class="n">delete_prediction_by_id_offer</span><span class="p">(</span><span class="n">id_offer</span><span class="p">)</span>

            <span class="n">dB</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="n">offer</span><span class="p">)</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="OfferManager.get_all_offers_with_field_in_base"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.get_all_offers_with_field_in_base">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_all_offers_with_field_in_base</span><span class="p">():</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Select all verify Prediction, i. e. the mark is 100 and the associate field (id_field) is a reference for an</span>
<span class="sd">        offer (id_offer)</span>

<span class="sd">        :return: Dictionary where each element is a list, in this list the first element is content of an offer and the second is id of field</span>
<span class="sd">        :rtype: Dictionary</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="c1">#  Renvoyer un tableau[2] : [0] -&gt; content offer | [1] -&gt; id field pour chaque offre ayant is_verify True</span>
        <span class="n">offers</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span> \
            <span class="o">.</span><span class="n">with_entities</span><span class="p">(</span><span class="n">Offer</span><span class="o">.</span><span class="n">content</span><span class="p">,</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">id_field</span><span class="p">)</span> \
            <span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">Prediction</span><span class="p">,</span> <span class="n">Offer</span><span class="o">.</span><span class="n">id</span> <span class="o">==</span> <span class="n">Prediction</span><span class="o">.</span><span class="n">id_offer</span><span class="p">)</span> \
            <span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">is_verify</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

        <span class="k">return</span> <span class="n">offers</span></div>

<div class="viewcode-block" id="OfferManager.offers_by_user"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.offer_manager.OfferManager.offers_by_user">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">offers_by_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>

<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: Offer with id_user associate</span>
<span class="sd">        :rtype: Offer serialize</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">offers</span> <span class="o">=</span> <span class="n">Offer</span><span class="o">.</span><span class="n">query</span> \
            <span class="o">.</span><span class="n">filter</span><span class="p">(</span><span class="n">Offer</span><span class="o">.</span><span class="n">id_user</span> <span class="o">==</span> <span class="n">id_user</span><span class="p">)</span>
        <span class="k">return</span> <span class="p">[</span><span class="n">o</span><span class="o">.</span><span class="n">serialize</span><span class="p">()</span> <span class="k">for</span> <span class="n">o</span> <span class="ow">in</span> <span class="n">offers</span><span class="p">]</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>